-- TODO: know for sure when turns of got milk are lost?
-- TODO: fullness when eating from cafes

local fullness_overrides = {
	[5224] = 1, -- Ur-Donut
}

local spleen_overrides = {
}

function eaten_food(itemid, usetext)
	local item = get_item_data_by_id(itemid)
	local fullness = nil
	if item and item.name then
		fullness = tonumber(item.fullness)
	elseif fullness_overrides[itemid] then
		fullness = fullness_overrides[itemid]
	end
	for x in (usetext .. "<p><center><b>and then...</b></center></p>"):gmatch("(.-)<p><center><b>and then%.%.%.</b></center></p>") do
		if x:match([[<img src="http://images.kingdomofloathing.com/itemimages/[^"]-%.gif" width=30 height=30>]]) then
			if not x:match(">You're too full to") and not x:match("You must be at least level .- to eat this item") then
-- 				print("ate food", printstr(item), x)
				if fullness then
					increase_daily_counter("fullness", fullness)
				else
					day["unknown fullness"] = "yes"
					print("Unknown food item, id:", itemid)
				end
			end
		end
	end
end

function used_spleen(itemid, quantity, usetext)
	local item = get_item_data_by_id(itemid)
	if item and item.name then
		if item.spleen then
			if not usetext:match("bad for your spleen.  That .- would cause it to rupture.<") and not usetext:match("You need to be at least level .- to use that item") then
		-- 		print("used spleen", quantity, printstr(item), usetext)
				if tonumber(item.spleen) then
					increase_daily_counter("spleen", tonumber(item.spleen) * quantity)
				else
					day["unknown spleen"] = "yes"
				end
			end
		end
	else
		day["unknown spleen"] = "yes"
		print("Unknown spleen item, id:", itemid)
	end
end

add_processor("/inv_eat.php", function()
	eaten_food(tonumber(params.whichitem), text)
end)

-- posting page /sushi.php params: Just [("action","Yep."),("pwd","bc24379b44f024724b28de075dd2f860"),("whichsushi","5"),("whichtopping","3819"),("whichfilling1","0")]
-- got uri: /sushi.php |  (from /sushi.php), size 3698

add_processor("/inv_use.php", function()
	used_spleen(tonumber(params.whichitem), tonumber(params.itemquantity) or 1, text)
end)

add_processor("/multiuse.php", function()
	if not params.whichitem then return end
	used_spleen(tonumber(params.whichitem), tonumber(params.quantity), text)
end)

add_processor("/inventory.php", function()
	if requestpath == "/inv_eat.php" then
		eaten_food(tonumber(params.whichitem), text:match([[<div id="effdiv">.-</div>]]))
	end
	if requestpath == "/inv_use.php" then
		used_spleen(tonumber(params.whichitem), 1, text:match([[<div id="effdiv">.-</div>]]))
	end
end)


add_printer("/charpane.php", function()
	local fullness = tostring(get_daily_counter("fullness"))
	local spleen = tostring(get_daily_counter("spleen"))
	if day["unknown fullness"] == "yes" then
		fullness = fullness .. "+?"
	end
	if day["unknown spleen"] == "yes" then
		spleen = spleen .. "+?"
	end

	if compact_charpane then
		text = text:gsub([[(<hr width=50%%>.-)(</table><hr width=50%%><table align=center cellpadding=1 cellspacing=1>)]], function (a, b)
			local fulltext = ""
			local spleentext = ""
			if fullness ~= "0" then
				fulltext = [[<tr><td align=right>Full:</td><td align=left><b>]] .. fullness .. [[</b></td></tr>]]
			end
			if spleen ~= "0" then
				spleentext = [[<tr><td align=right>Spleen:</td><td align=left><b>]] .. spleen .. [[</b></td></tr>]]
			end
			if a:match(">Drunk:<") then
				return a:gsub([[(.-)(<tr><td align=right>Drunk:</td><td align=left><b>[0-9,]-</b></td></tr>)]], function (x, y)
					return x .. fulltext .. y .. spleentext
				end) .. b
			else
				return a .. fulltext .. spleentext .. b
			end
		end)
	end

	if normal_charpane then
		text = text:gsub([[^(.-)(<table cellpadding=3 align=center>)]], function (a, b)
			local fulltext = ""
			local spleentext = ""
			if fullness ~= "0" then
				local fullness_descriptions = { "Fullness", "Satiation", "Engorgement" }
				local fullness_description = fullness_descriptions[math.random(1, table.maxn(fullness_descriptions))]
				fulltext = [[<tr><td align=right>]] .. fullness_description .. [[:</td><td><b>]] .. fullness .. [[</b></td></tr>]]
			end
			if spleen ~= "0" then
				local spleen_descriptions = { "Spleen", "Melancholy", "Moroseness" }
				local spleen_description = spleen_descriptions[math.random(1, table.maxn(spleen_descriptions))]
				spleentext = [[<tr><td align=right>]] .. spleen_description .. [[:</td><td><b>]] .. spleen .. [[</b></td></tr>]]
			end
			if a:match("<tr><td align=right>[^<]-</td><td><b>[0-9,]-</b></td></tr>") then
				return a:gsub([[(.-)(<tr><td align=right>[^<]-</td><td><b>[0-9,]-</b></td></tr>)]], function (x, y)
					return x .. fulltext .. y .. spleentext
				end) .. b
			else
				return a:gsub("</table>$", function() return fulltext .. spleentext .. "</table>" .. b end)
			end
			return a .. b
		end)
	end
end)

-- TODO: warn when using frosty mug
add_always_warning("/inv_booze.php", function()
	if buff("Ode to Booze") then return end
	function should_have_ode()
		if ascensionstatus() == "Aftercore" then
			return true
		end
		local pt = get_page("/skills.php")
		if pt:contains("Ode to Booze") then
			return true
		end
		return false
	end
	if should_have_ode() then
		return "You do not have Ode to Booze active", "drinking without ode"
	end
end)
